/*
 * OPALE is a scientific library under LGPL. Its main goal is to
 * develop mathematical tools for any scientist.
 *
 * Copyright (C) 2002 Opale Group
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * You can visit the web site http://opale.tuxfamily.org to obtain more
 * informations about this program and/or to contact the authors by mail
 * developers@opale.tuxfamily.org.
 */

package otests.m2d.Line;

import opale.tools.*;
import opale.m2d.*;
import opale.m2d.object2d.*;
import java.awt.*;
import java.awt.event.*;


public class Line extends Frame implements OTest
	{
	OIJ repere;
	LinLinCS vue;
	GAxis2D axes;
	GLine2D line1,line2,line3;
	
	public  void run(String path)
		{
		setSize(400,400);
		
		repere = new OIJ();
		vue = new LinLinCS(repere,25,25,350,350);
		
		axes = new GAxis2D(vue);
		((InfoAxis) axes.getInfo()).setTick(0,1,0,1);
		
		try
		{
		line1 = new GLine2D(repere,1,1,1);	//x+y1=0
		line2 = new GLine2D(repere,1,-1,0);	//x=y		
		line3 = new GLine2D(repere,1,-1,6);	//x=y		
		}
		catch (LineException e)
		{
		System.out.println (e); // ne devrait jamais arriver.
		}
		
		line1.getInfo().setColor(Color.blue);
		line2.getInfo().setColor(Color.red);
		line3.getInfo().setColor(Color.yellow);


		addComponentListener(new ComponentAdapter()
		{
		public void componentResized(ComponentEvent e)
			{
			vue.setSize(25,25,getWidth()-50,getHeight()-50);
			vue.normadjust();
			repaint();
			}
		});

		System.out.println("Droite bleue : "+line1);		
		System.out.println("Droite rouge : "+line2);						System.out.println("Droite jaune : "+line3);		
		System.out.println();		
		System.out.println("Droite bleue et rouge parallles : "+line1.isParall(line2));		
		System.out.println("Droite bleue et jaune parallles : "+line1.isParall(line3));		
		System.out.println("Droite rouge et jaune parallles : "+line2.isParall(line3));		
		System.out.println();		
		System.out.println("Droite bleue et rouge orthogonales : "+line1.isOrtho(line2));		
		System.out.println("Droite bleue et jaune orthogonales : "+line1.isOrtho(line3));		
		System.out.println("Droite rouge et jaune orthogonales : "+line2.isOrtho(line3));		

		show();
		}
		
	public void paint(Graphics g)
		{
		Pen2D c = new Pen2D(g,vue);
		axes.draw(c);

		line1.draw(c);
		line2.draw(c);
		line3.draw(c);
		
		}
		
		
		
		
public void stop()
	{
	dispose();
	}
	
	

	}
