/*
 * OPALE is a scientific library under LGPL. Its main goal is to
 * develop mathematical tools for any scientist.
 *
 * Copyright (C) 2002 Opale Group
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * You can visit the web site http://opale.tuxfamily.org to obtain more
 * informations about this program and/or to contact the authors by mail
 * developers@opale.tuxfamily.org.
 */

package otests.ode.file;

import opale.ode.*;
import opale.ode.scheme.*;
import opale.tools.*;


public class file implements OTest
{

public void run(String path)
	{
	
	try
	{
	ODE ode = new ODE();
	StreamReader rf = new StreamReader(path+"file1.ode");
	ode.read(rf);
	ode.solve();
	System.err.println(((Problem) ode.getObject("pb")).printSol());
	
	rf = new StreamReader(path+"file2.ode");
	ode.clear();
	ode.read(rf);
	ode.solve();
	System.err.println(((Problem) ode.getObject("pb_rk")).printSol());
	
	}
	catch(java.io.IOException e)
	{}	
	catch(InvalidFormatException e)
	{System.err.println(e);}	
	}

public void stop() {};

}
	
