/*
 * OPALE is a scientific library under LGPL. Its main goal is to
 * develop mathematical tools for any scientist.
 *
 * Copyright (C) 2002 Opale Group
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * You can visit the web site http://opale.tuxfamily.org to obtain more
 * informations about this program and/or to contact the authors by mail
 * developers@opale.tuxfamily.org.
 */

import opale.mathtools.*;

public class root
{
public static void main(String[] arg)
	{
	Bisection solve = new Bisection();
	System.err.println("1) This test case is a good example of bisection's method. F(x) = x*x-2 has an unique root (sqrt(2)) between 0 and 2.");
	System.out.println("ROOT = "+solve.find(
				new IyFx() {
					public double val(double x)
					{
					return x*x-2;
					}
					}
					,0,2)); 
	System.out.println("NITER = "+solve.NITER);

	System.err.println("\n2) In this test case the bisection's method converges to a singularity.\n F(x) = 1/(x-2) and 2 is a singularity of the function.");
	System.out.println("ROOT = "+solve.find(
				new IyFx() {
					public double val(double x)
					{
					return 1/(x-2);
					}
					}
					,1,3)); 
	System.out.println("NITER = "+solve.NITER);

	System.err.println("\n3) In this test case the function F(x) = sin(50*x)/x has many root between 0 and 2. It's difficult to know the root computed by the bisection's method.");
	System.out.println("ROOT = "+solve.find(
				new IyFx() {
					public double val(double x)
					{
					return Math.sin(x*50)/x;
					}
					}
					,0,2)); 
	System.out.println("NITER = "+solve.NITER);


	System.err.println("\n4) In this test case the bisection's method doesn't converge because the function (x-2)*(x-2) has a double root 2 but doesn't change of sign.");
	System.out.println("ROOT = "+solve.find(
				new IyFx() {
					public double val(double x)
					{
					return (x-2)*(x-2);
					}
					}
					,1,3)); 
	System.out.println("NITER = "+solve.NITER);



	}
}
