/*
 * OPALE is a scientific library under LGPL. Its main goal is to
 * develop mathematical tools for any scientist.
 *
 * Copyright (C) 2002 Opale Group
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * You can visit the web site http://opale.tuxfamily.org to obtain more
 * informations about this program and/or to contact the authors by mail
 * developers@opale.tuxfamily.org.
 */

import opale.*;
import opale.ode.*;
import opale.ode.scheme.*;
import opale.tools.*;
import java.io.*;

public class ode
{

public static void main(String[] arg)
	{
	
	try
	{
	OpaleSet ode = new OpaleSet();
	StreamReader rf = new StreamReader("file1.ode");
	ode.read(rf);
	//ode.solve();
	((Problem) ode.getObject("pb")).solve();
	//System.err.println(((Problem) ode.getObject("pb")).printSol());
	
	rf = new StreamReader("file2.ode");
	ode.clear();
	ode.read(rf);
	//ode.solve();
	((Problem) ode.getObject("pb_ee")).solve();
	//System.err.println(((Problem) ode.getObject("pb_ee")).printSol());
	
	WFile wf = new WFile("wfile.ode");
	ode.write(wf);
	wf.close();

	rf = new StreamReader("wfile.ode");
	ode.clear();
	ode.read(rf);
	((Problem) ode.getObject("pb_ee")).solve();
	System.err.println(((Problem) ode.getObject("pb_ee")).printSol());
	}
	catch(java.io.IOException e)
	{}	
	catch(InvalidFormatException e)
	{System.err.println(e);}	
	}

}
	
